/*
 * State.java
 *
 * Created on 13. prosinec 2006, 21:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package uloha4;

import java.util.Date;
import java.util.Random;

/**
 *
 * @author zelial
 */
public class State {
    private boolean[][] board = new boolean[8][8];
    
    /** Creates a new instance of State */
    public State(){
        for (int i = 0;i<8;i++){
            for (int r =0;r<8;r++){
                board[i][r]=false;
            }
        }
        /*
        //naplnime pozici ze zadani
        board[0][3]=true;
        board[1][2]=true;
        board[2][1]=true;
        board[3][4]=true;
        board[4][3]=true;
        board[5][2]=true;
        board[6][1]=true;
        board[7][2]=true;
         */
        
        //nahodna pozice
        Random rnd = new Random(new Date().getTime());
        for (int i =0;i<8;i++){
            board[i][Math.abs(rnd.nextInt()%8)]=true;
        }
         
        
        /*
         //jeden tah do vitezstvi - test funkcnosti
        board[0][1]=true;
        board[1][3]=true;
        board[2][5]=true;
        board[3][7]=true;
        board[4][2]=true;
        board[5][0]=true;
        board[6][6]=true;
        board[7][3]=true;
         **/
    }
    /** Copy constructor*/
    public State(State old){
        for (int i = 0;i<8;i++){
            for (int r =0;r<8;r++){
                board[i][r]=old.getField(i,r);
            }
        }
    }
    public void print(){
        System.out.println("+-+-+-+-+-+-+-+-+");
        for (int r = 7;r>=0;r--){
            for (int s =0;s<8;s++){
                System.out.print((board[s][r]?"|X":"| "));
            }
            System.out.println("+");
            //System.out.println("+-+-+-+-+-+-+-+-+");
        }
        System.out.println("+-+-+-+-+-+-+-+-+");
    }
    //vrati radek, kde se v danem sloupci nachazi dama
    public int getRow(int col){
        for (int i = 0;i<8;i++){
            if (board[col][i]==true){
                return i;
            }
        }
        return -1;
    }
    //vrati true, pokud se damy ve sloupcich col1 a col2 napadaji
    public boolean isConflict(int col1, int col2){
        if (getRow(col1)==getRow(col2)){
            return true;
        }
        if (Math.abs(col1-col2)==Math.abs(getRow(col1)-getRow(col2))){
            return true;
        }
        return false;
    }
    
    public int getHExtended(boolean printConflicts){
        int counter = 0;
        for (int s=0;s<7;s++){
            for (int i=s+1;i<8;i++){
                if (isConflict(s,i)){
                    if (printConflicts){
                        System.out.println("Konflict: "+s+", "+i);
                    }
                    counter++;
                }
            }
        }
        return counter;
    }
    public int getH(){
        return getHExtended(false);
    }
    //presune damu ve sloupci col na radek row
    public void moveToRow(int col, int row){
        for (int i = 0; i<8;i++){
            if (i==row){
                board[col][i]=true;
            }else{
                board[col][i]=false;
            }
        }
    }
    //vrati co je na sloupci col a radku row
    public boolean getField(int col, int row){
        return board[col][row];
    }
    
    public boolean[][] getBoard() {
        return board;
    }
}
